<template>
  <q-dialog ref="fakeDialog" />
</template>

<script>
/**
 * This weird component is a hacky way to use Quasar unexposed HistoryMixin for Android back button management by using the QDialog component.
 * When the map fullscreen is toggled, it adds or removes an entry into the Quasar history.
 * On Android when the back button is pressed, the event is handled by Quasar which trigger the hide method (redefined here)
 * ! FIX_MIGRATION not used anymore after migrating to Quasar 2 as the history mixin is no longer accessbie by the dialog plugin
 */
export default {
  name: 'MapFullscreenBackButtonHandler',
  props: {
    map: {
      type: Object,
      required: true
    }
  },
  mounted () {
    // Ugly workaround to override the hide method as I could not make the Vue extends mechanism work
    this.$refs.fakeDialog.hide = this.hide
    // Listen for fullscreenchange events
    this.map.on('fullscreenchange', this.onFullscreenChange)
  },
  beforeUnmount () {
    if (this.map) {
      this.map.off('fullscreenchange', this.onFullscreenChange)
    }
  },
  methods: {
    onFullscreenChange () {
      if (this.map && this.map.isFullscreen()) {
        this.$refs.fakeDialog.__addHistory.call(this)
      } else {
        this.$refs.fakeDialog.__removeHistory.call(this)
      }
    },
    hide () {
      if (this.map && this.map.isFullscreen()) {
        this.map.toggleFullscreen()
      }
    }
  }
}
</script>
